#include "StdAfx.h"
#include "Dialog.h"

#define PROPERTY_STRING _T("DialogClassInstance")

Dialog::Dialog(void)
	: m_hDlg( NULL )
	, m_idResource( 0 )
{
}

Dialog::~Dialog(void)
{
}

INT_PTR Dialog::DoModal( HWND hParent )
{
	return _DoModal( m_idResource, hParent );
}

HWND Dialog::SetFocus(void)
{
	return m_hDlg ? ::SetFocus( m_hDlg ) : NULL;
}

INT_PTR CALLBACK Dialog::_RootDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	Dialog *dlg = NULL;

	switch( uMsg )
	{
	case WM_INITDIALOG:
		dlg = (Dialog*)lParam;
		if ( dlg ) {
			SetProp( hDlg, PROPERTY_STRING, (HANDLE)dlg );
			dlg->m_hDlg = hDlg;
		}
		break;

	case WM_DESTROY:
		RemoveProp( hDlg, PROPERTY_STRING );
		break;
	}

	dlg = (Dialog*)GetProp( hDlg, PROPERTY_STRING );
	if ( dlg ) {
		return dlg->DlgProc( uMsg, wParam, lParam );
	}

	return 0;
}

INT_PTR Dialog::_DoModal(UINT idResource, HWND hParent)
{
	HINSTANCE hInstance = (HINSTANCE)GetWindowLong( hParent, GWL_HINSTANCE );
	
	return DialogBoxParam( hInstance, MAKEINTRESOURCE(idResource), hParent, (DLGPROC)_RootDlgProc, (LPARAM)this );
}
