#ifndef _DIALOG_H_
#define _DIALOG_H_

#include <windows.h>

class Dialog
{
public:
	Dialog(void);
	virtual ~Dialog(void);

	virtual INT_PTR _DoModal(UINT idResource, HWND hParent = NULL);
	virtual INT_PTR DoModal(HWND hParent = NULL);
	virtual HWND SetFocus(void);

protected:
	HWND m_hDlg;
	UINT m_idResource;
	static INT_PTR CALLBACK _RootDlgProc( HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam );
	virtual INT_PTR CALLBACK DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam ) = 0;

	BOOL SetItemText( int nIDDlgItem, LPCTSTR lpString )
	{
		return SetDlgItemText( m_hDlg, nIDDlgItem, lpString );
	}
	BOOL GetItemText( int nIDDlgItem, LPTSTR lpString, int nMaxCount )
	{
		return GetDlgItemText( m_hDlg, nIDDlgItem, lpString, nMaxCount );
	}
	BOOL SetItemInt( int nIDDlgItem, UINT uValue, BOOL bSigned )
	{
		return SetDlgItemInt( m_hDlg, nIDDlgItem, uValue, bSigned );
	}
	UINT GetItemInt( int nIDDlgItem, BOOL *lpTranslated, BOOL bSigned )
	{
		return GetDlgItemInt( m_hDlg, nIDDlgItem, lpTranslated, bSigned );
	}
	void SetCheck( int nIDDlgItem, int state )
	{
		SendDlgItemMessage( m_hDlg, nIDDlgItem, BM_SETCHECK, state, 0 );
	}
	UINT GetCheck( int nIDDlgItem )
	{
		return SendDlgItemMessage( m_hDlg, nIDDlgItem, BM_GETCHECK, 0, 0 );
	}
};

#endif//_DIALOG_H_
