#include "StdAfx.h"
#include "PrivateProfile.h"

PrivateProfile::PrivateProfile( TCHAR *ext )
{
	TCHAR temp[_MAX_PATH];
	TCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fext[_MAX_EXT];

	GetModuleFileName( NULL, temp, _MAX_PATH );
	_tsplitpath_s( temp, drive, _MAX_DRIVE, dir, _MAX_DIR, appName, _MAX_PATH, fext, _MAX_EXT );
#ifndef _DEBUG
	_tmakepath_s( profName, drive, dir, appName, ext );
#else
	GetCurrentDirectory( _MAX_PATH, profName );
	_tcscat_s( profName, MAX_PATH, _T("\\") );
	_tcscat_s( profName, MAX_PATH, appName );
	_tcscat_s( profName, MAX_PATH, ext );
#endif
}

PrivateProfile::~PrivateProfile(void)
{
}

BOOL PrivateProfile::WriteInt( UINT value, UINT def, TCHAR *key )
{
	BOOL bRet = TRUE;

	if ( value != GetPrivateProfileInt( appName, key, def, profName ) ) {
		TCHAR temp[256];
		_stprintf_s( temp, 256, _T("%d"), value );
		bRet = WritePrivateProfileString( appName, key, temp, profName );
	}

	return bRet;
}

BOOL PrivateProfile::WriteString( const TCHAR *value, TCHAR *def, TCHAR *key )
{
	BOOL bRet = TRUE;
	TCHAR temp[2048];

	GetPrivateProfileString( appName, key, def, temp, 2048, profName );
	if ( _tcscmp( value, temp ) != 0 ) {
		bRet = WritePrivateProfileString( appName, key, value, profName );
	}

	return bRet;
}

