#ifndef _BLACKOUT_SETTING_H_
#define _BLACKOUT_SETTING_H_

#include "PrivateProfile.h"
#include <string>
typedef std::basic_string<TCHAR> tstring;

class Setting : public PrivateProfile
{
public:
	typedef struct _SETTINGS
	{
		tstring user;
		tstring pass;
		int interval;
		int count;
		int delay;
		BOOL planned;
		BOOL sleep;
		BOOL offpeak;
	} SETTINGS;

public:
	Setting(void);
	virtual ~Setting(void);

	void Load(void);
	BOOL Save(void);
	BOOL ShowDialog(void);

	BOOL CreateTask( SYSTEMTIME *st );
	void GetFromNow( SYSTEMTIME *st );

	int interval(void) { return settings.interval; }
	int count(void) { return settings.count; }
	int delay(void) { return settings.delay; }
	const TCHAR *user(void) { return settings.user.c_str(); };
	const TCHAR *pass(void) { return settings.pass.c_str(); };
	int planned(void) { return settings.planned; }
	int sleep(void) { return settings.sleep; }
	int offpeak(void) { return settings.offpeak; }

protected:
	SETTINGS settings;
	BOOL Compare( SETTINGS *org, SETTINGS *dest );

	BOOL Setting::EncryptPass( tstring &org, tstring &dest );
	BOOL Setting::DecryptPass( tstring &org, tstring &dest );
	BOOL WritePass( const TCHAR *value, TCHAR *def, TCHAR *key );
};

#endif//_BLACKOUT_SETTING_H_