#include "StdAfx.h"
#include "SettingDlg.h"

SettingDlg::SettingDlg( UINT idResource )
{
	m_idResource = idResource;
}

SettingDlg::~SettingDlg(void)
{
}

INT_PTR CALLBACK SettingDlg::DlgProc( UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	int wmId, wmEvent;
	TCHAR temp[1024];

	switch( uMsg )
	{
	case WM_INITDIALOG:
		SetItemText( IDC_EDIT_USER, setting.user.c_str() );
		SetItemText( IDC_EDIT_PASSWORD, setting.pass.c_str() );
		SetItemInt( IDC_EDIT_INTERVAL, setting.interval, FALSE );
		SetItemInt( IDC_EDIT_COUNT, setting.count, FALSE );
		SetItemInt( IDC_EDIT_DELAY, setting.delay, FALSE );
		SetCheck( IDC_CHK_PLANNED, setting.planned );
		SetCheck( IDC_CHK_SLEEP, setting.sleep );
		SetCheck( IDC_CHK_OFFPEAK, setting.offpeak );
		return (INT_PTR)TRUE;
		break;

	case WM_COMMAND:
		wmId	= LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch( wmId )
		{
		case IDOK:
			{
				INT_PTR result = IDOK;

				GetItemText( IDC_EDIT_USER,		temp, sizeof(temp) );
				setting.user = temp;

				GetItemText( IDC_EDIT_PASSWORD,	temp, sizeof(temp) );
				setting.pass = temp;

				setting.interval	= GetItemInt( IDC_EDIT_INTERVAL,	NULL, FALSE );
				if ( setting.interval == 0 ) {
					result = IDCANCEL;
				}

				setting.count		= GetItemInt( IDC_EDIT_COUNT,		NULL, FALSE );
				if ( setting.count == 0 ) {
					result = IDCANCEL;
				}

				setting.delay		= GetItemInt( IDC_EDIT_DELAY,		NULL, FALSE );
				if ( setting.delay == 0 ) {
					result = IDCANCEL;
				}

				setting.planned	= GetCheck( IDC_CHK_PLANNED );
				setting.sleep	= GetCheck( IDC_CHK_SLEEP );
				setting.offpeak	= GetCheck( IDC_CHK_OFFPEAK );

				EndDialog( m_hDlg, result );
			}
			break;

		case IDCANCEL:
			EndDialog( m_hDlg, wmId );
			break;
		}
		break;
	}

	return 0;
}
